import {
  Controller,
  Post,
  Body,
  UsePipes,
  Get,
  UseGuards,
  Param,
} from '@nestjs/common';
import { TaskService } from './task.service';
import { Roles } from '../shared/roles.decorator';
import { ValidationPipe } from '../shared/validation.pipe';
import { TaskDTO } from './task.dto';

@Controller('task')
export class TaskController {
  constructor(private taskService: TaskService) {}

  /*   @Post('new')
  @UseGuards(new AuthGuard())
  @UsePipes(new ValidationPipe())
  async newGame(@User('id') person, @Body() body: GameDTO) {
    return this.gameservice.createNewGame(person, body);
  }

  @Put(':id')
  @Roles('admin')
  @UsePipes(new ValidationPipe())
  async editGame(@Param('id') id: string, @Body() body: GameDTO) {
    return this.gameservice.editGame(id, body);
  } */

  // creates a new task if the user has admin role in the game
  // :id is the id of the game
  @Post('new-task/:id')
  @Roles('admin')
  @UsePipes(new ValidationPipe())
  async newTask(@Param('id') id: string, @Body() task: TaskDTO) {
    return this.taskService.newTask(task);
  }
}
